# coding: utf-8


"""
IGNORE:
    Nutanix Virtual Machine Management APIs

    Manage the life-cycle of virtual machines hosted on Nutanix  # noqa: E501

    OpenAPI spec version: 4.0.1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
IGNORE
"""
import pprint
import json
import ast
import re  # noqa: F401

import six
from pathlib import Path
from ntnx_vmm_py_client.models.common.v1.response.ApiLink import ApiLink  # noqa: F401,E501
from ntnx_vmm_py_client.models.common.v1.response.ExternalizableAbstractModel import ExternalizableAbstractModel  # noqa: F401,E501
from ntnx_vmm_py_client.models.vmm.v4.ahv.policies.CategoryReference import CategoryReference  # noqa: F401,E501
from ntnx_vmm_py_client.models.vmm.v4.ahv.policies.UserReference import UserReference  # noqa: F401,E501

class VmHostAffinityPolicy(ExternalizableAbstractModel):

    """VM-Host Affinity policy configuration.

    :param name: (:attr:`name`) VM-Host Affinity policy name.
    :type name: 
     max=80 chars
    
    :param description: (:attr:`description`) VM-Host Affinity policy description.
    :type description: 
    
    
    :param create_time: (:attr:`create_time`) VM-Host Affinity policy creation time.
    :type create_time: 
    
    
    :param update_time: (:attr:`update_time`) VM-Host Affinity policy last updated time.
    :type update_time: 
    
    
    :param created_by: (:attr:`created_by`) 
    :type created_by: 
    
    
    :param last_updated_by: (:attr:`last_updated_by`) 
    :type last_updated_by: 
    
    
    :param vm_categories: (:attr:`vm_categories`) Categories through which VM is associated with the VM-host affinity policy.
    :type vm_categories: 
    
    
    :param host_categories: (:attr:`host_categories`) Categories through which host is associated with the VM-host affinity policy.
    :type host_categories: 
    
    
    :param num_vms: (:attr:`num_vms`) Number of VMs associated with the VM-host affinity policy.
    :type num_vms: 
    
    
    :param num_hosts: (:attr:`num_hosts`) Number of hosts associated with the VM-host affinity policy.
    :type num_hosts: 
    
    
    :param num_compliant_vms: (:attr:`num_compliant_vms`) Number of VMs which are compliant with the VM-host affinity policy.
    :type num_compliant_vms: 
    
    
    :param num_non_compliant_vms: (:attr:`num_non_compliant_vms`) Number of VMs which are not compliant with the VM-host affinity policy.
    :type num_non_compliant_vms: 
    
    

    """
    """
    IGNORE:
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    IGNORE
    """  # noqa: E501
    swagger_types = {
        'name': 'str',
        'description': 'str',
        'create_time': 'datetime',
        'update_time': 'datetime',
        'created_by': 'vmm.v4.ahv.policies.UserReference',
        'last_updated_by': 'vmm.v4.ahv.policies.UserReference',
        'vm_categories': 'list[vmm.v4.ahv.policies.CategoryReference]',
        'host_categories': 'list[vmm.v4.ahv.policies.CategoryReference]',
        'num_vms': 'int',
        'num_hosts': 'int',
        'num_compliant_vms': 'int',
        'num_non_compliant_vms': 'int',
        'ext_id': 'str',
        'links': 'list[common.v1.response.ApiLink]',
        'tenant_id': 'str',
        '_reserved': 'dict(str, object)',
        '_object_type': 'str',
        '_unknown_fields': 'dict(str, object)',
    }

    attribute_map = {
        'name': 'name',
        'description': 'description',
        'create_time': 'createTime',
        'update_time': 'updateTime',
        'created_by': 'createdBy',
        'last_updated_by': 'lastUpdatedBy',
        'vm_categories': 'vmCategories',
        'host_categories': 'hostCategories',
        'num_vms': 'numVms',
        'num_hosts': 'numHosts',
        'num_compliant_vms': 'numCompliantVms',
        'num_non_compliant_vms': 'numNonCompliantVms',
        'ext_id': 'extId',
        'links': 'links',
        'tenant_id': 'tenantId',
        '_reserved': '$reserved',
        '_object_type': '$objectType',
        '_unknown_fields': '$unknownFields',
    }



    def __init__(self, name=None, description=None, create_time=None, update_time=None, created_by=None, last_updated_by=None, vm_categories=None, host_categories=None, num_vms=None, num_hosts=None, num_compliant_vms=None, num_non_compliant_vms=None, ext_id=None, links=None, tenant_id=None, *args, **kwargs):  # noqa: E501
        ExternalizableAbstractModel.__init__(self, ext_id, links, tenant_id, *args, **kwargs)
        self.__name = None
        self.__description = None
        self.__create_time = None
        self.__update_time = None
        self.__created_by = None
        self.__last_updated_by = None
        self.__vm_categories = None
        self.__host_categories = None
        self.__num_vms = None
        self.__num_hosts = None
        self.__num_compliant_vms = None
        self.__num_non_compliant_vms = None
        self.discriminator = None
        if name is not None:
            self.__name = name
        if description is not None:
            self.__description = description
        if create_time is not None:
            self.__create_time = create_time
        if update_time is not None:
            self.__update_time = update_time
        if created_by is not None:
            self.__created_by = created_by
        if last_updated_by is not None:
            self.__last_updated_by = last_updated_by
        if vm_categories is not None:
            self.__vm_categories = vm_categories
        if host_categories is not None:
            self.__host_categories = host_categories
        if num_vms is not None:
            self.__num_vms = num_vms
        if num_hosts is not None:
            self.__num_hosts = num_hosts
        if num_compliant_vms is not None:
            self.__num_compliant_vms = num_compliant_vms
        if num_non_compliant_vms is not None:
            self.__num_non_compliant_vms = num_non_compliant_vms

    def _initialize_object_type(self):
        return 'vmm.v4.ahv.policies.VmHostAffinityPolicy'

    def _initialize_object_version(self):
        return 'v4.r0'


    @property
    def name(self):
        """
        VM-Host Affinity policy name.

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__name

    @name.setter
    def name(self, name):
        if name is not None and len(name) > 80:
            raise ValueError("Invalid value for `name`, length must be less than or equal to `80`")  # noqa: E501

        self.__name = name

    @property
    def description(self):
        """
        VM-Host Affinity policy description.

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__description

    @description.setter
    def description(self, description):

        self.__description = description

    @property
    def create_time(self):
        """
        VM-Host Affinity policy creation time.

        :type:
                :class:`~datetime`
        """  # noqa: E501
        return self.__create_time

    @create_time.setter
    def create_time(self, create_time):

        self.__create_time = create_time

    @property
    def update_time(self):
        """
        VM-Host Affinity policy last updated time.

        :type:
                :class:`~datetime`
        """  # noqa: E501
        return self.__update_time

    @update_time.setter
    def update_time(self, update_time):

        self.__update_time = update_time

    @property
    def created_by(self):
        """
        

        :type:
            :class:`~ntnx_vmm_py_client.models.vmm.v4.ahv.policies.UserReference`
        """  # noqa: E501
        return self.__created_by

    @created_by.setter
    def created_by(self, created_by):

        self.__created_by = created_by

    @property
    def last_updated_by(self):
        """
        

        :type:
            :class:`~ntnx_vmm_py_client.models.vmm.v4.ahv.policies.UserReference`
        """  # noqa: E501
        return self.__last_updated_by

    @last_updated_by.setter
    def last_updated_by(self, last_updated_by):

        self.__last_updated_by = last_updated_by

    @property
    def vm_categories(self):
        """
        Categories through which VM is associated with the VM-host affinity policy.

        :type:
             list[ :class:`~ntnx_vmm_py_client.models.vmm.v4.ahv.policies.CategoryReference` ]
        """  # noqa: E501
        return self.__vm_categories

    @vm_categories.setter
    def vm_categories(self, vm_categories):

        self.__vm_categories = vm_categories

    @property
    def host_categories(self):
        """
        Categories through which host is associated with the VM-host affinity policy.

        :type:
             list[ :class:`~ntnx_vmm_py_client.models.vmm.v4.ahv.policies.CategoryReference` ]
        """  # noqa: E501
        return self.__host_categories

    @host_categories.setter
    def host_categories(self, host_categories):

        self.__host_categories = host_categories

    @property
    def num_vms(self):
        """
        Number of VMs associated with the VM-host affinity policy.

        :type:
                :class:`~int`
        """  # noqa: E501
        return self.__num_vms

    @num_vms.setter
    def num_vms(self, num_vms):

        self.__num_vms = num_vms

    @property
    def num_hosts(self):
        """
        Number of hosts associated with the VM-host affinity policy.

        :type:
                :class:`~int`
        """  # noqa: E501
        return self.__num_hosts

    @num_hosts.setter
    def num_hosts(self, num_hosts):

        self.__num_hosts = num_hosts

    @property
    def num_compliant_vms(self):
        """
        Number of VMs which are compliant with the VM-host affinity policy.

        :type:
                :class:`~int`
        """  # noqa: E501
        return self.__num_compliant_vms

    @num_compliant_vms.setter
    def num_compliant_vms(self, num_compliant_vms):

        self.__num_compliant_vms = num_compliant_vms

    @property
    def num_non_compliant_vms(self):
        """
        Number of VMs which are not compliant with the VM-host affinity policy.

        :type:
                :class:`~int`
        """  # noqa: E501
        return self.__num_non_compliant_vms

    @num_non_compliant_vms.setter
    def num_non_compliant_vms(self, num_non_compliant_vms):

        self.__num_non_compliant_vms = num_non_compliant_vms

    def _to_dict(self, sanitize):
        """Returns the model properties as a dict. Omits None properties based on the provided "sanitize" parameter.

        :param sanitize: A flag to omit None properties if set to True
        :type sanitize: bool
        """

        result = {}
        for attr, attr_type in six.iteritems(self.swagger_types):

            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x._to_dict(sanitize) if hasattr(x, "_to_dict") else x,
                    value
                ))
            elif hasattr(value, "_to_dict"):
                result[attr] = value._to_dict(sanitize)
            elif isinstance(value, Path):
                result[attr] = str(value)
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1]._to_dict(sanitize)) if hasattr(item[1], "_to_dict")
                    else (
                        (item[0], str(item[1])) if item[0] == 'path' and '$objectType' in value and value['$objectType'] == 'pathlib.Path'
                        else item
                    ),
                    six.iteritems(value)
                ))
            else:
                if sanitize:
                    if value is not None:
                        result[attr] = value
                else:
                    result[attr] = value
        if issubclass(VmHostAffinityPolicy, dict):
            for key, value in six.iteritems(self):
                result[key] = value

        return result

    def to_dict(self):
        """Returns the model properties as a dictionary"""
        return self._to_dict(False)

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self._to_dict(True))

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, VmHostAffinityPolicy):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other

