# coding: utf-8


"""
IGNORE:
    Nutanix Virtual Machine Management APIs

    Manage the life-cycle of virtual machines hosted on Nutanix  # noqa: E501

    OpenAPI spec version: 4.0.1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
IGNORE
"""
import pprint
import json
import ast
import re  # noqa: F401

import six
from pathlib import Path

class VmStatsTuple(object):

    """A collection of VM stats.

    :param check_score: (:attr:`check_score`) The VM NCC health check score.
    :type check_score: 
    
    
    :param cluster: (:attr:`cluster`) The UUID of the cluster on which the VM resides.
    :type cluster: 
    
    
    :param controller_avg_io_latency_micros: (:attr:`controller_avg_io_latency_micros`) The VM controller average I/O latency in microseconds.
    :type controller_avg_io_latency_micros: 
    
    
    :param controller_avg_read_io_latency_micros: (:attr:`controller_avg_read_io_latency_micros`) The VM controller average read I/O latency in microseconds.
    :type controller_avg_read_io_latency_micros: 
    
    
    :param controller_avg_read_io_size_kb: (:attr:`controller_avg_read_io_size_kb`) The VM controller average read I/O size in kilobytes.
    :type controller_avg_read_io_size_kb: 
    
    
    :param controller_avg_write_io_latency_micros: (:attr:`controller_avg_write_io_latency_micros`) The VM controller average write I/O latency in microseconds.
    :type controller_avg_write_io_latency_micros: 
    
    
    :param controller_avg_write_io_size_kb: (:attr:`controller_avg_write_io_size_kb`) The VM controller average write I/O size in kilobytes.
    :type controller_avg_write_io_size_kb: 
    
    
    :param controller_io_bandwidth_kbps: (:attr:`controller_io_bandwidth_kbps`) The VM controller I/O bandwidth in kilobytes per second.
    :type controller_io_bandwidth_kbps: 
    
    
    :param controller_num_io: (:attr:`controller_num_io`) The VM controller number of I/O requests.
    :type controller_num_io: 
    
    
    :param controller_num_iops: (:attr:`controller_num_iops`) The VM controller number of I/O operations per second.
    :type controller_num_iops: 
    
    
    :param controller_num_random_io: (:attr:`controller_num_random_io`) The VM controller number of random I/O.
    :type controller_num_random_io: 
    
    
    :param controller_num_read_io: (:attr:`controller_num_read_io`) The VM controller number of read I/O.
    :type controller_num_read_io: 
    
    
    :param controller_num_read_iops: (:attr:`controller_num_read_iops`) The VM controller number of read I/O operations per second.
    :type controller_num_read_iops: 
    
    
    :param controller_num_seq_io: (:attr:`controller_num_seq_io`) The VM controller number of sequential I/Os.
    :type controller_num_seq_io: 
    
    
    :param controller_num_write_io: (:attr:`controller_num_write_io`) The VM controller number of write I/O.
    :type controller_num_write_io: 
    
    
    :param controller_num_write_iops: (:attr:`controller_num_write_iops`) The VM controller number of write I/O operations per second.
    :type controller_num_write_iops: 
    
    
    :param controller_random_io_ppm: (:attr:`controller_random_io_ppm`) The VM controller number of random I/O PPM.
    :type controller_random_io_ppm: 
    
    
    :param controller_read_io_bandwidth_kbps: (:attr:`controller_read_io_bandwidth_kbps`) The VM controller number of read I/O bandwidth in kilobytes per second.
    :type controller_read_io_bandwidth_kbps: 
    
    
    :param controller_read_io_ppm: (:attr:`controller_read_io_ppm`) The VM controller number of read I/O PPM.
    :type controller_read_io_ppm: 
    
    
    :param controller_seq_io_ppm: (:attr:`controller_seq_io_ppm`) The VM controller number of sequential I/O PPM.
    :type controller_seq_io_ppm: 
    
    
    :param controller_storage_tier_ssd_usage_bytes: (:attr:`controller_storage_tier_ssd_usage_bytes`) The VM controller total usage on SSD tier for the VM.
    :type controller_storage_tier_ssd_usage_bytes: 
    
    
    :param controller_timespan_micros: (:attr:`controller_timespan_micros`) The VM controller timespan in microseconds.
    :type controller_timespan_micros: 
    
    
    :param controller_total_io_size_kb: (:attr:`controller_total_io_size_kb`) The VM controller number of total I/O size in kilobytes.
    :type controller_total_io_size_kb: 
    
    
    :param controller_total_io_time_micros: (:attr:`controller_total_io_time_micros`) The VM controller number of total I/O time in microseconds.
    :type controller_total_io_time_micros: 
    
    
    :param controller_total_read_io_size_kb: (:attr:`controller_total_read_io_size_kb`) The VM controller number of total read I/O size in kilobytes.
    :type controller_total_read_io_size_kb: 
    
    
    :param controller_total_read_io_time_micros: (:attr:`controller_total_read_io_time_micros`) The VM controller number of total read I/O time in microseconds.
    :type controller_total_read_io_time_micros: 
    
    
    :param controller_total_transformed_usage_bytes: (:attr:`controller_total_transformed_usage_bytes`) The VM controller number of total transformed usage in bytes.
    :type controller_total_transformed_usage_bytes: 
    
    
    :param controller_user_bytes: (:attr:`controller_user_bytes`) The VM controller user bytes.
    :type controller_user_bytes: 
    
    
    :param controller_write_io_bandwidth_kbps: (:attr:`controller_write_io_bandwidth_kbps`) The VM controller write I/O bandwidth in kilobytes per second.
    :type controller_write_io_bandwidth_kbps: 
    
    
    :param controller_write_io_ppm: (:attr:`controller_write_io_ppm`) The VM controller percentage of write I/O in parts per million.
    :type controller_write_io_ppm: 
    
    
    :param hypervisor_avg_io_latency_micros: (:attr:`hypervisor_avg_io_latency_micros`) The average I/O latency of the VM in microseconds
    :type hypervisor_avg_io_latency_micros: 
    
    
    :param hypervisor_cpu_ready_time_ppm: (:attr:`hypervisor_cpu_ready_time_ppm`) Percentage of time that the VM was ready, but could not get scheduled to run.
    :type hypervisor_cpu_ready_time_ppm: 
    
    
    :param hypervisor_cpu_usage_ppm: (:attr:`hypervisor_cpu_usage_ppm`) The CPU usage of the VM in parts per million.
    :type hypervisor_cpu_usage_ppm: 
    
    
    :param hypervisor_io_bandwidth_kbps: (:attr:`hypervisor_io_bandwidth_kbps`) The I/O bandwidth of the VM in kilobytes per second.
    :type hypervisor_io_bandwidth_kbps: 
    
    
    :param hypervisor_memory_usage_ppm: (:attr:`hypervisor_memory_usage_ppm`) Consolidated guest memory usage in percentage.
    :type hypervisor_memory_usage_ppm: 
    
    
    :param hypervisor_num_io: (:attr:`hypervisor_num_io`) The number of I/O by the VM.
    :type hypervisor_num_io: 
    
    
    :param hypervisor_num_iops: (:attr:`hypervisor_num_iops`) The number of I/O operations by the VM per second.
    :type hypervisor_num_iops: 
    
    
    :param hypervisor_num_read_io: (:attr:`hypervisor_num_read_io`) The number of read I/O operations by the VM.
    :type hypervisor_num_read_io: 
    
    
    :param hypervisor_num_read_iops: (:attr:`hypervisor_num_read_iops`) The number of read I/O operations by the VM per second.
    :type hypervisor_num_read_iops: 
    
    
    :param hypervisor_num_received_bytes: (:attr:`hypervisor_num_received_bytes`) The number of bytes received by the VM.
    :type hypervisor_num_received_bytes: 
    
    
    :param hypervisor_num_transmitted_bytes: (:attr:`hypervisor_num_transmitted_bytes`) The number of bytes transmitted by the VM.
    :type hypervisor_num_transmitted_bytes: 
    
    
    :param hypervisor_num_write_io: (:attr:`hypervisor_num_write_io`) The number of write I/O by the VM.
    :type hypervisor_num_write_io: 
    
    
    :param hypervisor_num_write_iops: (:attr:`hypervisor_num_write_iops`) The number of write I/O operations by the VM per second.
    :type hypervisor_num_write_iops: 
    
    
    :param hypervisor_read_io_bandwidth_kbps: (:attr:`hypervisor_read_io_bandwidth_kbps`) The number of read I/O bandwidth of the VM in kilobytes per second.
    :type hypervisor_read_io_bandwidth_kbps: 
    
    
    :param hypervisor_swap_in_rate_kbps: (:attr:`hypervisor_swap_in_rate_kbps`) The swap in rate of the VM in kilobytes per second.
    :type hypervisor_swap_in_rate_kbps: 
    
    
    :param hypervisor_swap_out_rate_kbps: (:attr:`hypervisor_swap_out_rate_kbps`) The swap out rate of the VM in kilobytes per second.
    :type hypervisor_swap_out_rate_kbps: 
    
    
    :param hypervisor_timespan_micros: (:attr:`hypervisor_timespan_micros`) The timespan of the VM in microseconds.
    :type hypervisor_timespan_micros: 
    
    
    :param hypervisor_total_io_size_kb: (:attr:`hypervisor_total_io_size_kb`) The total I/O size of the VM in kilobytes.
    :type hypervisor_total_io_size_kb: 
    
    
    :param hypervisor_total_io_time_micros: (:attr:`hypervisor_total_io_time_micros`) The total I/O time of the VM in microseconds.
    :type hypervisor_total_io_time_micros: 
    
    
    :param hypervisor_total_read_io_size_kb: (:attr:`hypervisor_total_read_io_size_kb`) The total read I/O size of the VM in kilobytes.
    :type hypervisor_total_read_io_size_kb: 
    
    
    :param hypervisor_write_io_bandwidth_kbps: (:attr:`hypervisor_write_io_bandwidth_kbps`) The write I/O bandwidth of the VM in kilobytes per second.
    :type hypervisor_write_io_bandwidth_kbps: 
    
    
    :param hypervisor_type: (:attr:`hypervisor_type`) Hypervisor type of the VM.
    :type hypervisor_type: 
    
    
    :param memory_usage_ppm: (:attr:`memory_usage_ppm`) The VM memory usage in PPM.
    :type memory_usage_ppm: 
    
    
    :param timestamp: (:attr:`timestamp`) The timestamp of a specific VM stats response data point.
    :type timestamp: 
    
    

    """
    """
    IGNORE:
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    IGNORE
    """  # noqa: E501
    swagger_types = {
        'check_score': 'int',
        'cluster': 'str',
        'controller_avg_io_latency_micros': 'int',
        'controller_avg_read_io_latency_micros': 'int',
        'controller_avg_read_io_size_kb': 'int',
        'controller_avg_write_io_latency_micros': 'int',
        'controller_avg_write_io_size_kb': 'int',
        'controller_io_bandwidth_kbps': 'int',
        'controller_num_io': 'int',
        'controller_num_iops': 'int',
        'controller_num_random_io': 'int',
        'controller_num_read_io': 'int',
        'controller_num_read_iops': 'int',
        'controller_num_seq_io': 'int',
        'controller_num_write_io': 'int',
        'controller_num_write_iops': 'int',
        'controller_random_io_ppm': 'int',
        'controller_read_io_bandwidth_kbps': 'int',
        'controller_read_io_ppm': 'int',
        'controller_seq_io_ppm': 'int',
        'controller_storage_tier_ssd_usage_bytes': 'int',
        'controller_timespan_micros': 'int',
        'controller_total_io_size_kb': 'int',
        'controller_total_io_time_micros': 'int',
        'controller_total_read_io_size_kb': 'int',
        'controller_total_read_io_time_micros': 'int',
        'controller_total_transformed_usage_bytes': 'int',
        'controller_user_bytes': 'int',
        'controller_write_io_bandwidth_kbps': 'int',
        'controller_write_io_ppm': 'int',
        'hypervisor_avg_io_latency_micros': 'int',
        'hypervisor_cpu_ready_time_ppm': 'int',
        'hypervisor_cpu_usage_ppm': 'int',
        'hypervisor_io_bandwidth_kbps': 'int',
        'hypervisor_memory_usage_ppm': 'int',
        'hypervisor_num_io': 'int',
        'hypervisor_num_iops': 'int',
        'hypervisor_num_read_io': 'int',
        'hypervisor_num_read_iops': 'int',
        'hypervisor_num_received_bytes': 'int',
        'hypervisor_num_transmitted_bytes': 'int',
        'hypervisor_num_write_io': 'int',
        'hypervisor_num_write_iops': 'int',
        'hypervisor_read_io_bandwidth_kbps': 'int',
        'hypervisor_swap_in_rate_kbps': 'int',
        'hypervisor_swap_out_rate_kbps': 'int',
        'hypervisor_timespan_micros': 'int',
        'hypervisor_total_io_size_kb': 'int',
        'hypervisor_total_io_time_micros': 'int',
        'hypervisor_total_read_io_size_kb': 'int',
        'hypervisor_write_io_bandwidth_kbps': 'int',
        'hypervisor_type': 'str',
        'memory_usage_ppm': 'int',
        'timestamp': 'datetime',
        '_reserved': 'dict(str, object)',
        '_object_type': 'str',
        '_unknown_fields': 'dict(str, object)',
    }

    attribute_map = {
        'check_score': 'checkScore',
        'cluster': 'cluster',
        'controller_avg_io_latency_micros': 'controllerAvgIoLatencyMicros',
        'controller_avg_read_io_latency_micros': 'controllerAvgReadIoLatencyMicros',
        'controller_avg_read_io_size_kb': 'controllerAvgReadIoSizeKb',
        'controller_avg_write_io_latency_micros': 'controllerAvgWriteIoLatencyMicros',
        'controller_avg_write_io_size_kb': 'controllerAvgWriteIoSizeKb',
        'controller_io_bandwidth_kbps': 'controllerIoBandwidthKbps',
        'controller_num_io': 'controllerNumIo',
        'controller_num_iops': 'controllerNumIops',
        'controller_num_random_io': 'controllerNumRandomIo',
        'controller_num_read_io': 'controllerNumReadIo',
        'controller_num_read_iops': 'controllerNumReadIops',
        'controller_num_seq_io': 'controllerNumSeqIo',
        'controller_num_write_io': 'controllerNumWriteIo',
        'controller_num_write_iops': 'controllerNumWriteIops',
        'controller_random_io_ppm': 'controllerRandomIoPpm',
        'controller_read_io_bandwidth_kbps': 'controllerReadIoBandwidthKbps',
        'controller_read_io_ppm': 'controllerReadIoPpm',
        'controller_seq_io_ppm': 'controllerSeqIoPpm',
        'controller_storage_tier_ssd_usage_bytes': 'controllerStorageTierSsdUsageBytes',
        'controller_timespan_micros': 'controllerTimespanMicros',
        'controller_total_io_size_kb': 'controllerTotalIoSizeKb',
        'controller_total_io_time_micros': 'controllerTotalIoTimeMicros',
        'controller_total_read_io_size_kb': 'controllerTotalReadIoSizeKb',
        'controller_total_read_io_time_micros': 'controllerTotalReadIoTimeMicros',
        'controller_total_transformed_usage_bytes': 'controllerTotalTransformedUsageBytes',
        'controller_user_bytes': 'controllerUserBytes',
        'controller_write_io_bandwidth_kbps': 'controllerWriteIoBandwidthKbps',
        'controller_write_io_ppm': 'controllerWriteIoPpm',
        'hypervisor_avg_io_latency_micros': 'hypervisorAvgIoLatencyMicros',
        'hypervisor_cpu_ready_time_ppm': 'hypervisorCpuReadyTimePpm',
        'hypervisor_cpu_usage_ppm': 'hypervisorCpuUsagePpm',
        'hypervisor_io_bandwidth_kbps': 'hypervisorIoBandwidthKbps',
        'hypervisor_memory_usage_ppm': 'hypervisorMemoryUsagePpm',
        'hypervisor_num_io': 'hypervisorNumIo',
        'hypervisor_num_iops': 'hypervisorNumIops',
        'hypervisor_num_read_io': 'hypervisorNumReadIo',
        'hypervisor_num_read_iops': 'hypervisorNumReadIops',
        'hypervisor_num_received_bytes': 'hypervisorNumReceivedBytes',
        'hypervisor_num_transmitted_bytes': 'hypervisorNumTransmittedBytes',
        'hypervisor_num_write_io': 'hypervisorNumWriteIo',
        'hypervisor_num_write_iops': 'hypervisorNumWriteIops',
        'hypervisor_read_io_bandwidth_kbps': 'hypervisorReadIoBandwidthKbps',
        'hypervisor_swap_in_rate_kbps': 'hypervisorSwapInRateKbps',
        'hypervisor_swap_out_rate_kbps': 'hypervisorSwapOutRateKbps',
        'hypervisor_timespan_micros': 'hypervisorTimespanMicros',
        'hypervisor_total_io_size_kb': 'hypervisorTotalIoSizeKb',
        'hypervisor_total_io_time_micros': 'hypervisorTotalIoTimeMicros',
        'hypervisor_total_read_io_size_kb': 'hypervisorTotalReadIoSizeKb',
        'hypervisor_write_io_bandwidth_kbps': 'hypervisorWriteIoBandwidthKbps',
        'hypervisor_type': 'hypervisorType',
        'memory_usage_ppm': 'memoryUsagePpm',
        'timestamp': 'timestamp',
        '_reserved': '$reserved',
        '_object_type': '$objectType',
        '_unknown_fields': '$unknownFields',
    }



    def __init__(self, check_score=None, cluster=None, controller_avg_io_latency_micros=None, controller_avg_read_io_latency_micros=None, controller_avg_read_io_size_kb=None, controller_avg_write_io_latency_micros=None, controller_avg_write_io_size_kb=None, controller_io_bandwidth_kbps=None, controller_num_io=None, controller_num_iops=None, controller_num_random_io=None, controller_num_read_io=None, controller_num_read_iops=None, controller_num_seq_io=None, controller_num_write_io=None, controller_num_write_iops=None, controller_random_io_ppm=None, controller_read_io_bandwidth_kbps=None, controller_read_io_ppm=None, controller_seq_io_ppm=None, controller_storage_tier_ssd_usage_bytes=None, controller_timespan_micros=None, controller_total_io_size_kb=None, controller_total_io_time_micros=None, controller_total_read_io_size_kb=None, controller_total_read_io_time_micros=None, controller_total_transformed_usage_bytes=None, controller_user_bytes=None, controller_write_io_bandwidth_kbps=None, controller_write_io_ppm=None, hypervisor_avg_io_latency_micros=None, hypervisor_cpu_ready_time_ppm=None, hypervisor_cpu_usage_ppm=None, hypervisor_io_bandwidth_kbps=None, hypervisor_memory_usage_ppm=None, hypervisor_num_io=None, hypervisor_num_iops=None, hypervisor_num_read_io=None, hypervisor_num_read_iops=None, hypervisor_num_received_bytes=None, hypervisor_num_transmitted_bytes=None, hypervisor_num_write_io=None, hypervisor_num_write_iops=None, hypervisor_read_io_bandwidth_kbps=None, hypervisor_swap_in_rate_kbps=None, hypervisor_swap_out_rate_kbps=None, hypervisor_timespan_micros=None, hypervisor_total_io_size_kb=None, hypervisor_total_io_time_micros=None, hypervisor_total_read_io_size_kb=None, hypervisor_write_io_bandwidth_kbps=None, hypervisor_type=None, memory_usage_ppm=None, timestamp=None, *args, **kwargs):  # noqa: E501
        self.__check_score = None
        self.__cluster = None
        self.__controller_avg_io_latency_micros = None
        self.__controller_avg_read_io_latency_micros = None
        self.__controller_avg_read_io_size_kb = None
        self.__controller_avg_write_io_latency_micros = None
        self.__controller_avg_write_io_size_kb = None
        self.__controller_io_bandwidth_kbps = None
        self.__controller_num_io = None
        self.__controller_num_iops = None
        self.__controller_num_random_io = None
        self.__controller_num_read_io = None
        self.__controller_num_read_iops = None
        self.__controller_num_seq_io = None
        self.__controller_num_write_io = None
        self.__controller_num_write_iops = None
        self.__controller_random_io_ppm = None
        self.__controller_read_io_bandwidth_kbps = None
        self.__controller_read_io_ppm = None
        self.__controller_seq_io_ppm = None
        self.__controller_storage_tier_ssd_usage_bytes = None
        self.__controller_timespan_micros = None
        self.__controller_total_io_size_kb = None
        self.__controller_total_io_time_micros = None
        self.__controller_total_read_io_size_kb = None
        self.__controller_total_read_io_time_micros = None
        self.__controller_total_transformed_usage_bytes = None
        self.__controller_user_bytes = None
        self.__controller_write_io_bandwidth_kbps = None
        self.__controller_write_io_ppm = None
        self.__hypervisor_avg_io_latency_micros = None
        self.__hypervisor_cpu_ready_time_ppm = None
        self.__hypervisor_cpu_usage_ppm = None
        self.__hypervisor_io_bandwidth_kbps = None
        self.__hypervisor_memory_usage_ppm = None
        self.__hypervisor_num_io = None
        self.__hypervisor_num_iops = None
        self.__hypervisor_num_read_io = None
        self.__hypervisor_num_read_iops = None
        self.__hypervisor_num_received_bytes = None
        self.__hypervisor_num_transmitted_bytes = None
        self.__hypervisor_num_write_io = None
        self.__hypervisor_num_write_iops = None
        self.__hypervisor_read_io_bandwidth_kbps = None
        self.__hypervisor_swap_in_rate_kbps = None
        self.__hypervisor_swap_out_rate_kbps = None
        self.__hypervisor_timespan_micros = None
        self.__hypervisor_total_io_size_kb = None
        self.__hypervisor_total_io_time_micros = None
        self.__hypervisor_total_read_io_size_kb = None
        self.__hypervisor_write_io_bandwidth_kbps = None
        self.__hypervisor_type = None
        self.__memory_usage_ppm = None
        self.__timestamp = None
        self.discriminator = None
        if check_score is not None:
            self.__check_score = check_score
        if cluster is not None:
            self.__cluster = cluster
        if controller_avg_io_latency_micros is not None:
            self.__controller_avg_io_latency_micros = controller_avg_io_latency_micros
        if controller_avg_read_io_latency_micros is not None:
            self.__controller_avg_read_io_latency_micros = controller_avg_read_io_latency_micros
        if controller_avg_read_io_size_kb is not None:
            self.__controller_avg_read_io_size_kb = controller_avg_read_io_size_kb
        if controller_avg_write_io_latency_micros is not None:
            self.__controller_avg_write_io_latency_micros = controller_avg_write_io_latency_micros
        if controller_avg_write_io_size_kb is not None:
            self.__controller_avg_write_io_size_kb = controller_avg_write_io_size_kb
        if controller_io_bandwidth_kbps is not None:
            self.__controller_io_bandwidth_kbps = controller_io_bandwidth_kbps
        if controller_num_io is not None:
            self.__controller_num_io = controller_num_io
        if controller_num_iops is not None:
            self.__controller_num_iops = controller_num_iops
        if controller_num_random_io is not None:
            self.__controller_num_random_io = controller_num_random_io
        if controller_num_read_io is not None:
            self.__controller_num_read_io = controller_num_read_io
        if controller_num_read_iops is not None:
            self.__controller_num_read_iops = controller_num_read_iops
        if controller_num_seq_io is not None:
            self.__controller_num_seq_io = controller_num_seq_io
        if controller_num_write_io is not None:
            self.__controller_num_write_io = controller_num_write_io
        if controller_num_write_iops is not None:
            self.__controller_num_write_iops = controller_num_write_iops
        if controller_random_io_ppm is not None:
            self.__controller_random_io_ppm = controller_random_io_ppm
        if controller_read_io_bandwidth_kbps is not None:
            self.__controller_read_io_bandwidth_kbps = controller_read_io_bandwidth_kbps
        if controller_read_io_ppm is not None:
            self.__controller_read_io_ppm = controller_read_io_ppm
        if controller_seq_io_ppm is not None:
            self.__controller_seq_io_ppm = controller_seq_io_ppm
        if controller_storage_tier_ssd_usage_bytes is not None:
            self.__controller_storage_tier_ssd_usage_bytes = controller_storage_tier_ssd_usage_bytes
        if controller_timespan_micros is not None:
            self.__controller_timespan_micros = controller_timespan_micros
        if controller_total_io_size_kb is not None:
            self.__controller_total_io_size_kb = controller_total_io_size_kb
        if controller_total_io_time_micros is not None:
            self.__controller_total_io_time_micros = controller_total_io_time_micros
        if controller_total_read_io_size_kb is not None:
            self.__controller_total_read_io_size_kb = controller_total_read_io_size_kb
        if controller_total_read_io_time_micros is not None:
            self.__controller_total_read_io_time_micros = controller_total_read_io_time_micros
        if controller_total_transformed_usage_bytes is not None:
            self.__controller_total_transformed_usage_bytes = controller_total_transformed_usage_bytes
        if controller_user_bytes is not None:
            self.__controller_user_bytes = controller_user_bytes
        if controller_write_io_bandwidth_kbps is not None:
            self.__controller_write_io_bandwidth_kbps = controller_write_io_bandwidth_kbps
        if controller_write_io_ppm is not None:
            self.__controller_write_io_ppm = controller_write_io_ppm
        if hypervisor_avg_io_latency_micros is not None:
            self.__hypervisor_avg_io_latency_micros = hypervisor_avg_io_latency_micros
        if hypervisor_cpu_ready_time_ppm is not None:
            self.__hypervisor_cpu_ready_time_ppm = hypervisor_cpu_ready_time_ppm
        if hypervisor_cpu_usage_ppm is not None:
            self.__hypervisor_cpu_usage_ppm = hypervisor_cpu_usage_ppm
        if hypervisor_io_bandwidth_kbps is not None:
            self.__hypervisor_io_bandwidth_kbps = hypervisor_io_bandwidth_kbps
        if hypervisor_memory_usage_ppm is not None:
            self.__hypervisor_memory_usage_ppm = hypervisor_memory_usage_ppm
        if hypervisor_num_io is not None:
            self.__hypervisor_num_io = hypervisor_num_io
        if hypervisor_num_iops is not None:
            self.__hypervisor_num_iops = hypervisor_num_iops
        if hypervisor_num_read_io is not None:
            self.__hypervisor_num_read_io = hypervisor_num_read_io
        if hypervisor_num_read_iops is not None:
            self.__hypervisor_num_read_iops = hypervisor_num_read_iops
        if hypervisor_num_received_bytes is not None:
            self.__hypervisor_num_received_bytes = hypervisor_num_received_bytes
        if hypervisor_num_transmitted_bytes is not None:
            self.__hypervisor_num_transmitted_bytes = hypervisor_num_transmitted_bytes
        if hypervisor_num_write_io is not None:
            self.__hypervisor_num_write_io = hypervisor_num_write_io
        if hypervisor_num_write_iops is not None:
            self.__hypervisor_num_write_iops = hypervisor_num_write_iops
        if hypervisor_read_io_bandwidth_kbps is not None:
            self.__hypervisor_read_io_bandwidth_kbps = hypervisor_read_io_bandwidth_kbps
        if hypervisor_swap_in_rate_kbps is not None:
            self.__hypervisor_swap_in_rate_kbps = hypervisor_swap_in_rate_kbps
        if hypervisor_swap_out_rate_kbps is not None:
            self.__hypervisor_swap_out_rate_kbps = hypervisor_swap_out_rate_kbps
        if hypervisor_timespan_micros is not None:
            self.__hypervisor_timespan_micros = hypervisor_timespan_micros
        if hypervisor_total_io_size_kb is not None:
            self.__hypervisor_total_io_size_kb = hypervisor_total_io_size_kb
        if hypervisor_total_io_time_micros is not None:
            self.__hypervisor_total_io_time_micros = hypervisor_total_io_time_micros
        if hypervisor_total_read_io_size_kb is not None:
            self.__hypervisor_total_read_io_size_kb = hypervisor_total_read_io_size_kb
        if hypervisor_write_io_bandwidth_kbps is not None:
            self.__hypervisor_write_io_bandwidth_kbps = hypervisor_write_io_bandwidth_kbps
        if hypervisor_type is not None:
            self.__hypervisor_type = hypervisor_type
        if memory_usage_ppm is not None:
            self.__memory_usage_ppm = memory_usage_ppm
        if timestamp is not None:
            self.__timestamp = timestamp
        # populate hidden vars if not empty
        self._populate_hidden_vars(kwargs)

    def _initialize_object_type(self):
        return 'vmm.v4.esxi.stats.VmStatsTuple'

    def _initialize_object_version(self):
        return 'v4.r0'

    def _populate_hidden_vars(self, kwargs):
        if "_reserved" in kwargs and kwargs["_reserved"] is not None:
            self.__dollar_reserved = kwargs["_reserved"]
        elif hasattr(self, "attribute_map") and "_reserved" in self.attribute_map and self.attribute_map["_reserved"] in kwargs and kwargs[self.attribute_map["_reserved"]] is not None:
            self.__dollar_reserved = kwargs[self.attribute_map["_reserved"]]
        else :
            self.__dollar_reserved = {"$fv": self._initialize_object_version()}
        if "_unknown_fields" in kwargs and kwargs["_unknown_fields"] is not None:
            self.__dollar_unknown_fields = kwargs["_unknown_fields"]
        elif hasattr(self, "attribute_map") and "_unknown_fields" in self.attribute_map and self.attribute_map["_unknown_fields"] in kwargs and kwargs[self.attribute_map["_unknown_fields"]] is not None:
            self.__dollar_unknown_fields = kwargs[self.attribute_map["_unknown_fields"]]
        else :
            self.__dollar_unknown_fields = {}
        if "_object_type" in kwargs and kwargs["_object_type"] is not None:
            self.__dollar_object_type = kwargs["_object_type"]
        elif hasattr(self, "attribute_map") and "_object_type" in self.attribute_map and self.attribute_map["_object_type"] in kwargs and kwargs[self.attribute_map["_object_type"]] is not None:
            self.__dollar_object_type = kwargs[self.attribute_map["_object_type"]]
        else:
            self.__dollar_object_type = self._initialize_object_type()

    def get_object_type(self):
        return self.__dollar_object_type

    def get_reserved(self):
        return self.__dollar_reserved

    def get_unknown_fields(self):
        return self.__dollar_unknown_fields

    @property
    def check_score(self):
        """
        The VM NCC health check score.

        :type:
                :class:`~int`
        """  # noqa: E501
        return self.__check_score

    @check_score.setter
    def check_score(self, check_score):

        self.__check_score = check_score

    @property
    def cluster(self):
        """
        The UUID of the cluster on which the VM resides.

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__cluster

    @cluster.setter
    def cluster(self, cluster):

        self.__cluster = cluster

    @property
    def controller_avg_io_latency_micros(self):
        """
        The VM controller average I/O latency in microseconds.

        :type:
                :class:`~int`
        """  # noqa: E501
        return self.__controller_avg_io_latency_micros

    @controller_avg_io_latency_micros.setter
    def controller_avg_io_latency_micros(self, controller_avg_io_latency_micros):

        self.__controller_avg_io_latency_micros = controller_avg_io_latency_micros

    @property
    def controller_avg_read_io_latency_micros(self):
        """
        The VM controller average read I/O latency in microseconds.

        :type:
                :class:`~int`
        """  # noqa: E501
        return self.__controller_avg_read_io_latency_micros

    @controller_avg_read_io_latency_micros.setter
    def controller_avg_read_io_latency_micros(self, controller_avg_read_io_latency_micros):

        self.__controller_avg_read_io_latency_micros = controller_avg_read_io_latency_micros

    @property
    def controller_avg_read_io_size_kb(self):
        """
        The VM controller average read I/O size in kilobytes.

        :type:
                :class:`~int`
        """  # noqa: E501
        return self.__controller_avg_read_io_size_kb

    @controller_avg_read_io_size_kb.setter
    def controller_avg_read_io_size_kb(self, controller_avg_read_io_size_kb):

        self.__controller_avg_read_io_size_kb = controller_avg_read_io_size_kb

    @property
    def controller_avg_write_io_latency_micros(self):
        """
        The VM controller average write I/O latency in microseconds.

        :type:
                :class:`~int`
        """  # noqa: E501
        return self.__controller_avg_write_io_latency_micros

    @controller_avg_write_io_latency_micros.setter
    def controller_avg_write_io_latency_micros(self, controller_avg_write_io_latency_micros):

        self.__controller_avg_write_io_latency_micros = controller_avg_write_io_latency_micros

    @property
    def controller_avg_write_io_size_kb(self):
        """
        The VM controller average write I/O size in kilobytes.

        :type:
                :class:`~int`
        """  # noqa: E501
        return self.__controller_avg_write_io_size_kb

    @controller_avg_write_io_size_kb.setter
    def controller_avg_write_io_size_kb(self, controller_avg_write_io_size_kb):

        self.__controller_avg_write_io_size_kb = controller_avg_write_io_size_kb

    @property
    def controller_io_bandwidth_kbps(self):
        """
        The VM controller I/O bandwidth in kilobytes per second.

        :type:
                :class:`~int`
        """  # noqa: E501
        return self.__controller_io_bandwidth_kbps

    @controller_io_bandwidth_kbps.setter
    def controller_io_bandwidth_kbps(self, controller_io_bandwidth_kbps):

        self.__controller_io_bandwidth_kbps = controller_io_bandwidth_kbps

    @property
    def controller_num_io(self):
        """
        The VM controller number of I/O requests.

        :type:
                :class:`~int`
        """  # noqa: E501
        return self.__controller_num_io

    @controller_num_io.setter
    def controller_num_io(self, controller_num_io):

        self.__controller_num_io = controller_num_io

    @property
    def controller_num_iops(self):
        """
        The VM controller number of I/O operations per second.

        :type:
                :class:`~int`
        """  # noqa: E501
        return self.__controller_num_iops

    @controller_num_iops.setter
    def controller_num_iops(self, controller_num_iops):

        self.__controller_num_iops = controller_num_iops

    @property
    def controller_num_random_io(self):
        """
        The VM controller number of random I/O.

        :type:
                :class:`~int`
        """  # noqa: E501
        return self.__controller_num_random_io

    @controller_num_random_io.setter
    def controller_num_random_io(self, controller_num_random_io):

        self.__controller_num_random_io = controller_num_random_io

    @property
    def controller_num_read_io(self):
        """
        The VM controller number of read I/O.

        :type:
                :class:`~int`
        """  # noqa: E501
        return self.__controller_num_read_io

    @controller_num_read_io.setter
    def controller_num_read_io(self, controller_num_read_io):

        self.__controller_num_read_io = controller_num_read_io

    @property
    def controller_num_read_iops(self):
        """
        The VM controller number of read I/O operations per second.

        :type:
                :class:`~int`
        """  # noqa: E501
        return self.__controller_num_read_iops

    @controller_num_read_iops.setter
    def controller_num_read_iops(self, controller_num_read_iops):

        self.__controller_num_read_iops = controller_num_read_iops

    @property
    def controller_num_seq_io(self):
        """
        The VM controller number of sequential I/Os.

        :type:
                :class:`~int`
        """  # noqa: E501
        return self.__controller_num_seq_io

    @controller_num_seq_io.setter
    def controller_num_seq_io(self, controller_num_seq_io):

        self.__controller_num_seq_io = controller_num_seq_io

    @property
    def controller_num_write_io(self):
        """
        The VM controller number of write I/O.

        :type:
                :class:`~int`
        """  # noqa: E501
        return self.__controller_num_write_io

    @controller_num_write_io.setter
    def controller_num_write_io(self, controller_num_write_io):

        self.__controller_num_write_io = controller_num_write_io

    @property
    def controller_num_write_iops(self):
        """
        The VM controller number of write I/O operations per second.

        :type:
                :class:`~int`
        """  # noqa: E501
        return self.__controller_num_write_iops

    @controller_num_write_iops.setter
    def controller_num_write_iops(self, controller_num_write_iops):

        self.__controller_num_write_iops = controller_num_write_iops

    @property
    def controller_random_io_ppm(self):
        """
        The VM controller number of random I/O PPM.

        :type:
                :class:`~int`
        """  # noqa: E501
        return self.__controller_random_io_ppm

    @controller_random_io_ppm.setter
    def controller_random_io_ppm(self, controller_random_io_ppm):

        self.__controller_random_io_ppm = controller_random_io_ppm

    @property
    def controller_read_io_bandwidth_kbps(self):
        """
        The VM controller number of read I/O bandwidth in kilobytes per second.

        :type:
                :class:`~int`
        """  # noqa: E501
        return self.__controller_read_io_bandwidth_kbps

    @controller_read_io_bandwidth_kbps.setter
    def controller_read_io_bandwidth_kbps(self, controller_read_io_bandwidth_kbps):

        self.__controller_read_io_bandwidth_kbps = controller_read_io_bandwidth_kbps

    @property
    def controller_read_io_ppm(self):
        """
        The VM controller number of read I/O PPM.

        :type:
                :class:`~int`
        """  # noqa: E501
        return self.__controller_read_io_ppm

    @controller_read_io_ppm.setter
    def controller_read_io_ppm(self, controller_read_io_ppm):

        self.__controller_read_io_ppm = controller_read_io_ppm

    @property
    def controller_seq_io_ppm(self):
        """
        The VM controller number of sequential I/O PPM.

        :type:
                :class:`~int`
        """  # noqa: E501
        return self.__controller_seq_io_ppm

    @controller_seq_io_ppm.setter
    def controller_seq_io_ppm(self, controller_seq_io_ppm):

        self.__controller_seq_io_ppm = controller_seq_io_ppm

    @property
    def controller_storage_tier_ssd_usage_bytes(self):
        """
        The VM controller total usage on SSD tier for the VM.

        :type:
                :class:`~int`
        """  # noqa: E501
        return self.__controller_storage_tier_ssd_usage_bytes

    @controller_storage_tier_ssd_usage_bytes.setter
    def controller_storage_tier_ssd_usage_bytes(self, controller_storage_tier_ssd_usage_bytes):

        self.__controller_storage_tier_ssd_usage_bytes = controller_storage_tier_ssd_usage_bytes

    @property
    def controller_timespan_micros(self):
        """
        The VM controller timespan in microseconds.

        :type:
                :class:`~int`
        """  # noqa: E501
        return self.__controller_timespan_micros

    @controller_timespan_micros.setter
    def controller_timespan_micros(self, controller_timespan_micros):

        self.__controller_timespan_micros = controller_timespan_micros

    @property
    def controller_total_io_size_kb(self):
        """
        The VM controller number of total I/O size in kilobytes.

        :type:
                :class:`~int`
        """  # noqa: E501
        return self.__controller_total_io_size_kb

    @controller_total_io_size_kb.setter
    def controller_total_io_size_kb(self, controller_total_io_size_kb):

        self.__controller_total_io_size_kb = controller_total_io_size_kb

    @property
    def controller_total_io_time_micros(self):
        """
        The VM controller number of total I/O time in microseconds.

        :type:
                :class:`~int`
        """  # noqa: E501
        return self.__controller_total_io_time_micros

    @controller_total_io_time_micros.setter
    def controller_total_io_time_micros(self, controller_total_io_time_micros):

        self.__controller_total_io_time_micros = controller_total_io_time_micros

    @property
    def controller_total_read_io_size_kb(self):
        """
        The VM controller number of total read I/O size in kilobytes.

        :type:
                :class:`~int`
        """  # noqa: E501
        return self.__controller_total_read_io_size_kb

    @controller_total_read_io_size_kb.setter
    def controller_total_read_io_size_kb(self, controller_total_read_io_size_kb):

        self.__controller_total_read_io_size_kb = controller_total_read_io_size_kb

    @property
    def controller_total_read_io_time_micros(self):
        """
        The VM controller number of total read I/O time in microseconds.

        :type:
                :class:`~int`
        """  # noqa: E501
        return self.__controller_total_read_io_time_micros

    @controller_total_read_io_time_micros.setter
    def controller_total_read_io_time_micros(self, controller_total_read_io_time_micros):

        self.__controller_total_read_io_time_micros = controller_total_read_io_time_micros

    @property
    def controller_total_transformed_usage_bytes(self):
        """
        The VM controller number of total transformed usage in bytes.

        :type:
                :class:`~int`
        """  # noqa: E501
        return self.__controller_total_transformed_usage_bytes

    @controller_total_transformed_usage_bytes.setter
    def controller_total_transformed_usage_bytes(self, controller_total_transformed_usage_bytes):

        self.__controller_total_transformed_usage_bytes = controller_total_transformed_usage_bytes

    @property
    def controller_user_bytes(self):
        """
        The VM controller user bytes.

        :type:
                :class:`~int`
        """  # noqa: E501
        return self.__controller_user_bytes

    @controller_user_bytes.setter
    def controller_user_bytes(self, controller_user_bytes):

        self.__controller_user_bytes = controller_user_bytes

    @property
    def controller_write_io_bandwidth_kbps(self):
        """
        The VM controller write I/O bandwidth in kilobytes per second.

        :type:
                :class:`~int`
        """  # noqa: E501
        return self.__controller_write_io_bandwidth_kbps

    @controller_write_io_bandwidth_kbps.setter
    def controller_write_io_bandwidth_kbps(self, controller_write_io_bandwidth_kbps):

        self.__controller_write_io_bandwidth_kbps = controller_write_io_bandwidth_kbps

    @property
    def controller_write_io_ppm(self):
        """
        The VM controller percentage of write I/O in parts per million.

        :type:
                :class:`~int`
        """  # noqa: E501
        return self.__controller_write_io_ppm

    @controller_write_io_ppm.setter
    def controller_write_io_ppm(self, controller_write_io_ppm):

        self.__controller_write_io_ppm = controller_write_io_ppm

    @property
    def hypervisor_avg_io_latency_micros(self):
        """
        The average I/O latency of the VM in microseconds

        :type:
                :class:`~int`
        """  # noqa: E501
        return self.__hypervisor_avg_io_latency_micros

    @hypervisor_avg_io_latency_micros.setter
    def hypervisor_avg_io_latency_micros(self, hypervisor_avg_io_latency_micros):

        self.__hypervisor_avg_io_latency_micros = hypervisor_avg_io_latency_micros

    @property
    def hypervisor_cpu_ready_time_ppm(self):
        """
        Percentage of time that the VM was ready, but could not get scheduled to run.

        :type:
                :class:`~int`
        """  # noqa: E501
        return self.__hypervisor_cpu_ready_time_ppm

    @hypervisor_cpu_ready_time_ppm.setter
    def hypervisor_cpu_ready_time_ppm(self, hypervisor_cpu_ready_time_ppm):

        self.__hypervisor_cpu_ready_time_ppm = hypervisor_cpu_ready_time_ppm

    @property
    def hypervisor_cpu_usage_ppm(self):
        """
        The CPU usage of the VM in parts per million.

        :type:
                :class:`~int`
        """  # noqa: E501
        return self.__hypervisor_cpu_usage_ppm

    @hypervisor_cpu_usage_ppm.setter
    def hypervisor_cpu_usage_ppm(self, hypervisor_cpu_usage_ppm):

        self.__hypervisor_cpu_usage_ppm = hypervisor_cpu_usage_ppm

    @property
    def hypervisor_io_bandwidth_kbps(self):
        """
        The I/O bandwidth of the VM in kilobytes per second.

        :type:
                :class:`~int`
        """  # noqa: E501
        return self.__hypervisor_io_bandwidth_kbps

    @hypervisor_io_bandwidth_kbps.setter
    def hypervisor_io_bandwidth_kbps(self, hypervisor_io_bandwidth_kbps):

        self.__hypervisor_io_bandwidth_kbps = hypervisor_io_bandwidth_kbps

    @property
    def hypervisor_memory_usage_ppm(self):
        """
        Consolidated guest memory usage in percentage.

        :type:
                :class:`~int`
        """  # noqa: E501
        return self.__hypervisor_memory_usage_ppm

    @hypervisor_memory_usage_ppm.setter
    def hypervisor_memory_usage_ppm(self, hypervisor_memory_usage_ppm):

        self.__hypervisor_memory_usage_ppm = hypervisor_memory_usage_ppm

    @property
    def hypervisor_num_io(self):
        """
        The number of I/O by the VM.

        :type:
                :class:`~int`
        """  # noqa: E501
        return self.__hypervisor_num_io

    @hypervisor_num_io.setter
    def hypervisor_num_io(self, hypervisor_num_io):

        self.__hypervisor_num_io = hypervisor_num_io

    @property
    def hypervisor_num_iops(self):
        """
        The number of I/O operations by the VM per second.

        :type:
                :class:`~int`
        """  # noqa: E501
        return self.__hypervisor_num_iops

    @hypervisor_num_iops.setter
    def hypervisor_num_iops(self, hypervisor_num_iops):

        self.__hypervisor_num_iops = hypervisor_num_iops

    @property
    def hypervisor_num_read_io(self):
        """
        The number of read I/O operations by the VM.

        :type:
                :class:`~int`
        """  # noqa: E501
        return self.__hypervisor_num_read_io

    @hypervisor_num_read_io.setter
    def hypervisor_num_read_io(self, hypervisor_num_read_io):

        self.__hypervisor_num_read_io = hypervisor_num_read_io

    @property
    def hypervisor_num_read_iops(self):
        """
        The number of read I/O operations by the VM per second.

        :type:
                :class:`~int`
        """  # noqa: E501
        return self.__hypervisor_num_read_iops

    @hypervisor_num_read_iops.setter
    def hypervisor_num_read_iops(self, hypervisor_num_read_iops):

        self.__hypervisor_num_read_iops = hypervisor_num_read_iops

    @property
    def hypervisor_num_received_bytes(self):
        """
        The number of bytes received by the VM.

        :type:
                :class:`~int`
        """  # noqa: E501
        return self.__hypervisor_num_received_bytes

    @hypervisor_num_received_bytes.setter
    def hypervisor_num_received_bytes(self, hypervisor_num_received_bytes):

        self.__hypervisor_num_received_bytes = hypervisor_num_received_bytes

    @property
    def hypervisor_num_transmitted_bytes(self):
        """
        The number of bytes transmitted by the VM.

        :type:
                :class:`~int`
        """  # noqa: E501
        return self.__hypervisor_num_transmitted_bytes

    @hypervisor_num_transmitted_bytes.setter
    def hypervisor_num_transmitted_bytes(self, hypervisor_num_transmitted_bytes):

        self.__hypervisor_num_transmitted_bytes = hypervisor_num_transmitted_bytes

    @property
    def hypervisor_num_write_io(self):
        """
        The number of write I/O by the VM.

        :type:
                :class:`~int`
        """  # noqa: E501
        return self.__hypervisor_num_write_io

    @hypervisor_num_write_io.setter
    def hypervisor_num_write_io(self, hypervisor_num_write_io):

        self.__hypervisor_num_write_io = hypervisor_num_write_io

    @property
    def hypervisor_num_write_iops(self):
        """
        The number of write I/O operations by the VM per second.

        :type:
                :class:`~int`
        """  # noqa: E501
        return self.__hypervisor_num_write_iops

    @hypervisor_num_write_iops.setter
    def hypervisor_num_write_iops(self, hypervisor_num_write_iops):

        self.__hypervisor_num_write_iops = hypervisor_num_write_iops

    @property
    def hypervisor_read_io_bandwidth_kbps(self):
        """
        The number of read I/O bandwidth of the VM in kilobytes per second.

        :type:
                :class:`~int`
        """  # noqa: E501
        return self.__hypervisor_read_io_bandwidth_kbps

    @hypervisor_read_io_bandwidth_kbps.setter
    def hypervisor_read_io_bandwidth_kbps(self, hypervisor_read_io_bandwidth_kbps):

        self.__hypervisor_read_io_bandwidth_kbps = hypervisor_read_io_bandwidth_kbps

    @property
    def hypervisor_swap_in_rate_kbps(self):
        """
        The swap in rate of the VM in kilobytes per second.

        :type:
                :class:`~int`
        """  # noqa: E501
        return self.__hypervisor_swap_in_rate_kbps

    @hypervisor_swap_in_rate_kbps.setter
    def hypervisor_swap_in_rate_kbps(self, hypervisor_swap_in_rate_kbps):

        self.__hypervisor_swap_in_rate_kbps = hypervisor_swap_in_rate_kbps

    @property
    def hypervisor_swap_out_rate_kbps(self):
        """
        The swap out rate of the VM in kilobytes per second.

        :type:
                :class:`~int`
        """  # noqa: E501
        return self.__hypervisor_swap_out_rate_kbps

    @hypervisor_swap_out_rate_kbps.setter
    def hypervisor_swap_out_rate_kbps(self, hypervisor_swap_out_rate_kbps):

        self.__hypervisor_swap_out_rate_kbps = hypervisor_swap_out_rate_kbps

    @property
    def hypervisor_timespan_micros(self):
        """
        The timespan of the VM in microseconds.

        :type:
                :class:`~int`
        """  # noqa: E501
        return self.__hypervisor_timespan_micros

    @hypervisor_timespan_micros.setter
    def hypervisor_timespan_micros(self, hypervisor_timespan_micros):

        self.__hypervisor_timespan_micros = hypervisor_timespan_micros

    @property
    def hypervisor_total_io_size_kb(self):
        """
        The total I/O size of the VM in kilobytes.

        :type:
                :class:`~int`
        """  # noqa: E501
        return self.__hypervisor_total_io_size_kb

    @hypervisor_total_io_size_kb.setter
    def hypervisor_total_io_size_kb(self, hypervisor_total_io_size_kb):

        self.__hypervisor_total_io_size_kb = hypervisor_total_io_size_kb

    @property
    def hypervisor_total_io_time_micros(self):
        """
        The total I/O time of the VM in microseconds.

        :type:
                :class:`~int`
        """  # noqa: E501
        return self.__hypervisor_total_io_time_micros

    @hypervisor_total_io_time_micros.setter
    def hypervisor_total_io_time_micros(self, hypervisor_total_io_time_micros):

        self.__hypervisor_total_io_time_micros = hypervisor_total_io_time_micros

    @property
    def hypervisor_total_read_io_size_kb(self):
        """
        The total read I/O size of the VM in kilobytes.

        :type:
                :class:`~int`
        """  # noqa: E501
        return self.__hypervisor_total_read_io_size_kb

    @hypervisor_total_read_io_size_kb.setter
    def hypervisor_total_read_io_size_kb(self, hypervisor_total_read_io_size_kb):

        self.__hypervisor_total_read_io_size_kb = hypervisor_total_read_io_size_kb

    @property
    def hypervisor_write_io_bandwidth_kbps(self):
        """
        The write I/O bandwidth of the VM in kilobytes per second.

        :type:
                :class:`~int`
        """  # noqa: E501
        return self.__hypervisor_write_io_bandwidth_kbps

    @hypervisor_write_io_bandwidth_kbps.setter
    def hypervisor_write_io_bandwidth_kbps(self, hypervisor_write_io_bandwidth_kbps):

        self.__hypervisor_write_io_bandwidth_kbps = hypervisor_write_io_bandwidth_kbps

    @property
    def hypervisor_type(self):
        """
        Hypervisor type of the VM.

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__hypervisor_type

    @hypervisor_type.setter
    def hypervisor_type(self, hypervisor_type):

        self.__hypervisor_type = hypervisor_type

    @property
    def memory_usage_ppm(self):
        """
        The VM memory usage in PPM.

        :type:
                :class:`~int`
        """  # noqa: E501
        return self.__memory_usage_ppm

    @memory_usage_ppm.setter
    def memory_usage_ppm(self, memory_usage_ppm):

        self.__memory_usage_ppm = memory_usage_ppm

    @property
    def timestamp(self):
        """
        The timestamp of a specific VM stats response data point.

        :type:
                :class:`~datetime`
        """  # noqa: E501
        return self.__timestamp

    @timestamp.setter
    def timestamp(self, timestamp):

        self.__timestamp = timestamp

    @property
    def _reserved(self):
        """
        

        :type:
            dict(str, :class:`~object`)
        """  # noqa: E501
        return self.__dollar_reserved

    @property
    def _object_type(self):
        """
        

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__dollar_object_type

    @property
    def _unknown_fields(self):
        """
        

        :type:
            dict(str, :class:`~object`)
        """  # noqa: E501
        return self.__dollar_unknown_fields

    def _to_dict(self, sanitize):
        """Returns the model properties as a dict. Omits None properties based on the provided "sanitize" parameter.

        :param sanitize: A flag to omit None properties if set to True
        :type sanitize: bool
        """

        result = {}
        for attr, attr_type in six.iteritems(self.swagger_types):

            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x._to_dict(sanitize) if hasattr(x, "_to_dict") else x,
                    value
                ))
            elif hasattr(value, "_to_dict"):
                result[attr] = value._to_dict(sanitize)
            elif isinstance(value, Path):
                result[attr] = str(value)
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1]._to_dict(sanitize)) if hasattr(item[1], "_to_dict")
                    else (
                        (item[0], str(item[1])) if item[0] == 'path' and '$objectType' in value and value['$objectType'] == 'pathlib.Path'
                        else item
                    ),
                    six.iteritems(value)
                ))
            else:
                if sanitize:
                    if value is not None:
                        result[attr] = value
                else:
                    result[attr] = value
        if issubclass(VmStatsTuple, dict):
            for key, value in six.iteritems(self):
                result[key] = value

        return result

    def to_dict(self):
        """Returns the model properties as a dictionary"""
        return self._to_dict(False)

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self._to_dict(True))

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, VmStatsTuple):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other

