# coding: utf-8


"""
IGNORE:
    Nutanix Virtual Machine Management APIs

    Manage the life-cycle of virtual machines hosted on Nutanix  # noqa: E501

    OpenAPI spec version: 4.0.1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
IGNORE
"""
import pprint
import json
import ast
import re  # noqa: F401

import six
from pathlib import Path
from ntnx_vmm_py_client.models.common.v1.response.ApiLink import ApiLink  # noqa: F401,E501
from ntnx_vmm_py_client.models.common.v1.response.ExternalizableAbstractModel import ExternalizableAbstractModel  # noqa: F401,E501
from ntnx_vmm_py_client.models.vmm.v4.images.config.EnforcementState import EnforcementState  # noqa: F401,E501
from ntnx_vmm_py_client.models.vmm.v4.images.config.Filter import Filter  # noqa: F401,E501
from ntnx_vmm_py_client.models.vmm.v4.images.config.PlacementType import PlacementType  # noqa: F401,E501

class PlacementPolicy(ExternalizableAbstractModel):

    """

    :param name: (:attr:`name`) Name of the image placement policy.
    :type name: required
     min=1 chars, max=256 chars
    
    :param description: (:attr:`description`) Description of the image placement policy.
    :type description: 
     max=1000 chars
    
    :param placement_type: (:attr:`placement_type`) 
    :type placement_type: required
    
    
    :param image_entity_filter: (:attr:`image_entity_filter`) 
    :type image_entity_filter: required
    
    
    :param cluster_entity_filter: (:attr:`cluster_entity_filter`) 
    :type cluster_entity_filter: required
    
    
    :param enforcement_state: (:attr:`enforcement_state`) 
    :type enforcement_state: 
    
    
    :param create_time: (:attr:`create_time`) Image placement policy creation time.
    :type create_time: 
    
    
    :param last_update_time: (:attr:`last_update_time`) Last updated time of an image placement policy.
    :type last_update_time: 
    
    
    :param owner_ext_id: (:attr:`owner_ext_id`) External identifier of the owner of the image placement policy.
    :type owner_ext_id: 
    
    

    """
    """
    IGNORE:
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    IGNORE
    """  # noqa: E501
    swagger_types = {
        'name': 'str',
        'description': 'str',
        'placement_type': 'vmm.v4.images.config.PlacementType',
        'image_entity_filter': 'vmm.v4.images.config.Filter',
        'cluster_entity_filter': 'vmm.v4.images.config.Filter',
        'enforcement_state': 'vmm.v4.images.config.EnforcementState',
        'create_time': 'datetime',
        'last_update_time': 'datetime',
        'owner_ext_id': 'str',
        'ext_id': 'str',
        'links': 'list[common.v1.response.ApiLink]',
        'tenant_id': 'str',
        '_reserved': 'dict(str, object)',
        '_object_type': 'str',
        '_unknown_fields': 'dict(str, object)',
    }

    attribute_map = {
        'name': 'name',
        'description': 'description',
        'placement_type': 'placementType',
        'image_entity_filter': 'imageEntityFilter',
        'cluster_entity_filter': 'clusterEntityFilter',
        'enforcement_state': 'enforcementState',
        'create_time': 'createTime',
        'last_update_time': 'lastUpdateTime',
        'owner_ext_id': 'ownerExtId',
        'ext_id': 'extId',
        'links': 'links',
        'tenant_id': 'tenantId',
        '_reserved': '$reserved',
        '_object_type': '$objectType',
        '_unknown_fields': '$unknownFields',
    }



    def __init__(self, name=None, description=None, placement_type=None, image_entity_filter=None, cluster_entity_filter=None, enforcement_state=None, create_time=None, last_update_time=None, owner_ext_id=None, ext_id=None, links=None, tenant_id=None, *args, **kwargs):  # noqa: E501
        ExternalizableAbstractModel.__init__(self, ext_id, links, tenant_id, *args, **kwargs)
        self.__name = None
        self.__description = None
        self.__placement_type = None
        self.__image_entity_filter = None
        self.__cluster_entity_filter = None
        self.__enforcement_state = None
        self.__create_time = None
        self.__last_update_time = None
        self.__owner_ext_id = None
        self.discriminator = None
        self.__name = name
        if description is not None:
            self.__description = description
        self.__placement_type = placement_type
        self.__image_entity_filter = image_entity_filter
        self.__cluster_entity_filter = cluster_entity_filter
        if enforcement_state is not None:
            self.__enforcement_state = enforcement_state
        if create_time is not None:
            self.__create_time = create_time
        if last_update_time is not None:
            self.__last_update_time = last_update_time
        if owner_ext_id is not None:
            self.__owner_ext_id = owner_ext_id

    def _initialize_object_type(self):
        return 'vmm.v4.images.config.PlacementPolicy'

    def _initialize_object_version(self):
        return 'v4.r0'


    @property
    def name(self):
        """
        Name of the image placement policy.

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__name

    @name.setter
    def name(self, name):
        if name is None:
            raise ValueError("Invalid value for `name`, must not be `None`")  # noqa: E501
        if name is not None and len(name) > 256:
            raise ValueError("Invalid value for `name`, length must be less than or equal to `256`")  # noqa: E501
        if name is not None and len(name) < 1:
            raise ValueError("Invalid value for `name`, length must be greater than or equal to `1`")  # noqa: E501

        self.__name = name

    @property
    def description(self):
        """
        Description of the image placement policy.

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__description

    @description.setter
    def description(self, description):
        if description is not None and len(description) > 1000:
            raise ValueError("Invalid value for `description`, length must be less than or equal to `1000`")  # noqa: E501

        self.__description = description

    @property
    def placement_type(self):
        """
        

        :type:
            :class:`~ntnx_vmm_py_client.models.vmm.v4.images.config.PlacementType`
        """  # noqa: E501
        return self.__placement_type

    @placement_type.setter
    def placement_type(self, placement_type):
        if placement_type is None:
            raise ValueError("Invalid value for `placement_type`, must not be `None`")  # noqa: E501

        self.__placement_type = placement_type

    @property
    def image_entity_filter(self):
        """
        

        :type:
            :class:`~ntnx_vmm_py_client.models.vmm.v4.images.config.Filter`
        """  # noqa: E501
        return self.__image_entity_filter

    @image_entity_filter.setter
    def image_entity_filter(self, image_entity_filter):
        if image_entity_filter is None:
            raise ValueError("Invalid value for `image_entity_filter`, must not be `None`")  # noqa: E501

        self.__image_entity_filter = image_entity_filter

    @property
    def cluster_entity_filter(self):
        """
        

        :type:
            :class:`~ntnx_vmm_py_client.models.vmm.v4.images.config.Filter`
        """  # noqa: E501
        return self.__cluster_entity_filter

    @cluster_entity_filter.setter
    def cluster_entity_filter(self, cluster_entity_filter):
        if cluster_entity_filter is None:
            raise ValueError("Invalid value for `cluster_entity_filter`, must not be `None`")  # noqa: E501

        self.__cluster_entity_filter = cluster_entity_filter

    @property
    def enforcement_state(self):
        """
        

        :type:
            :class:`~ntnx_vmm_py_client.models.vmm.v4.images.config.EnforcementState`
        """  # noqa: E501
        return self.__enforcement_state

    @enforcement_state.setter
    def enforcement_state(self, enforcement_state):

        self.__enforcement_state = enforcement_state

    @property
    def create_time(self):
        """
        Image placement policy creation time.

        :type:
                :class:`~datetime`
        """  # noqa: E501
        return self.__create_time

    @create_time.setter
    def create_time(self, create_time):

        self.__create_time = create_time

    @property
    def last_update_time(self):
        """
        Last updated time of an image placement policy.

        :type:
                :class:`~datetime`
        """  # noqa: E501
        return self.__last_update_time

    @last_update_time.setter
    def last_update_time(self, last_update_time):

        self.__last_update_time = last_update_time

    @property
    def owner_ext_id(self):
        """
        External identifier of the owner of the image placement policy.

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__owner_ext_id

    @owner_ext_id.setter
    def owner_ext_id(self, owner_ext_id):
        if owner_ext_id is not None and not re.search('^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$', owner_ext_id):  # noqa: E501
            raise ValueError(r"Invalid value for `owner_ext_id`, must be a follow pattern or equal to `/^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$/`")  # noqa: E501

        self.__owner_ext_id = owner_ext_id

    def _to_dict(self, sanitize):
        """Returns the model properties as a dict. Omits None properties based on the provided "sanitize" parameter.

        :param sanitize: A flag to omit None properties if set to True
        :type sanitize: bool
        """

        result = {}
        for attr, attr_type in six.iteritems(self.swagger_types):

            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x._to_dict(sanitize) if hasattr(x, "_to_dict") else x,
                    value
                ))
            elif hasattr(value, "_to_dict"):
                result[attr] = value._to_dict(sanitize)
            elif isinstance(value, Path):
                result[attr] = str(value)
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1]._to_dict(sanitize)) if hasattr(item[1], "_to_dict")
                    else (
                        (item[0], str(item[1])) if item[0] == 'path' and '$objectType' in value and value['$objectType'] == 'pathlib.Path'
                        else item
                    ),
                    six.iteritems(value)
                ))
            else:
                if sanitize:
                    if value is not None:
                        result[attr] = value
                else:
                    result[attr] = value
        if issubclass(PlacementPolicy, dict):
            for key, value in six.iteritems(self):
                result[key] = value

        return result

    def to_dict(self):
        """Returns the model properties as a dictionary"""
        return self._to_dict(False)

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self._to_dict(True))

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, PlacementPolicy):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other

